package com.mobula.sample;

import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.provider.Settings;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.RelativeLayout;

import com.daps.weather.floatdisplay.FloatDisplayController;
import com.daps.weather.weathercard.DapWeatherView;

public class MainActivity extends AppCompatActivity {
    private static final String TAG = MainActivity.class.getSimpleName();
    private  DapWeatherView mDuWeatherView;
    private boolean isShow = true;
    private static int REQUEST_CODE = 10; 
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);


        //卡片入口
        //Add weather card View
        RelativeLayout rl = (RelativeLayout) findViewById(R.id.demo_weather_view_rl);
        mDuWeatherView = new DapWeatherView(this,DapWeatherView.VIEWSIZE_DEFAULT);

        rl.addView(mDuWeatherView);
        findViewById(R.id.btn_weather_view).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //天气卡片加载天气数据，有数据自动填充DapWeatherView卡片
                // load weather data, SDK will auto-fill DapWeatherView card if data is loaded.
                mDuWeatherView.load();
            }
        });

        //悬浮框入口
        //Floating window
        findViewById(R.id.btn_weather_suspension).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //悬浮窗入口，传入true开启，false关闭。
                // Floating window entrance，input “true” to enable，input ”false” to disable.
                FloatDisplayController.setFloatSearchWindowIsShow(getApplicationContext(), isShow);
                isShow = !isShow;
            }
        });

        //如果你们需要支持android6.0系统，需要做特殊处理如下
        //If you need to use floating windows in Android 6.0, please do the followings:

        //1.FloatDisplayController.setFloatSerachWindowIsShow(MainActivity.this, isShow);
        // 如果是传入activity.this的形式，不需要手动申请权限，sdk内部已经帮你处理了，不用进行以下步骤
        //If you use activity.this, SDK handle it for you, don't need to do it manually，ignore following steps.

        //2.FloatDisplayController.setFloatSerachWindowIsShow(applicationContext, isShow);
        // 如果是applicationContext的调用,需要在你的activity的oncreate()或者其他地方手动注册权限。
        //If you use applicationContext, please register permission manually under onCreate() of your activity or other place
        //例如在onCreate()中申请权限：
        //This is how to do in under onCreate():
        //start
//        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M && Build.VERSION.SDK_INT < Build.VERSION_CODES.N) {
//            if (!Settings.canDrawOverlays(MainActivity.this)) {
//                requestAlertWindowPermission();
//            }
//        }
        //end
    }

    // 3. 申请权限，REQUEST_CODE用来和返回码做匹配，值和以自定义
    // 3. Implement permission request，REQUEST_CODE is used to check return of request, defined by developer
    private void requestAlertWindowPermission() {
        Intent intent = new Intent(Settings.ACTION_MANAGE_OVERLAY_PERMISSION);
        intent.setData(Uri.parse("package:" + getPackageName()));
        startActivityForResult(intent, REQUEST_CODE);
    }

    // 4. 注册监听
    // 4. Register listener
//    @Override
//    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
//        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
//        if (requestCode == REQUEST_CODE) {
//            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M && Build.VERSION.SDK_INT < Build.VERSION_CODES.N) {
//                if (Settings.canDrawOverlays(this)) {
//                    Log.e(TAG, "获取到悬浮窗权限");
//                } else {
//                    Log.e(TAG, "无悬浮窗权限");
//                }
//            }
//        }
//    }
}
